set serveroutput on;

declare
  LF constant varchar2(1) := Chr(10);
  result pypl.pls_largest_varchar2;
begin
  -- Define a function. No result expected.
  result := pypl.run_script(
    'def my_mult(x, y):' || LF ||
    '  return x * y' || LF,
    null
  );
  dbms_output.put_line('Define function: ' || result);
  -- Use function.
  result := pypl.run_script(
    'x = 2' || LF ||
    'y = 6' || LF ||
    'result = str(my_mult(x, y))' || LF,
    'result'
  );
  dbms_output.put_line('x * y = ' || result);
  -- Re-use function.
  result := pypl.run_script(
    'a = 12' || LF ||
    'b = 4' || LF ||
    'result = str(my_mult(a, b))' || LF,
    'result'
  );
  dbms_output.put_line('a * b = ' || result);
  -- Error handling.
  begin
    -- This should raise an 'invalid syntax' error from pypl.
    result := pypl.run_script(
      'x = my_mult(a, ))' || LF,
      'result'
    );
    raise_application_error(-20000, 'The previous statement should have raised an exception.');
  exception
    when others then
      dbms_output.put_line('ERROR: ' || SQLERRM);
  end;
end;
/

